SystemOrganization addCategory: #ConfigurationOfSourceCity!

Object subclass: #ConfigurationOfSourceCity
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSourceCity'!

!ConfigurationOfSourceCity class methodsFor: 'development support' stamp: 'DouailleErwan 5/15/2012 15:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSourceCity class methodsFor: 'private' stamp: 'DouailleErwan 5/15/2012 15:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSourceCity class methodsFor: 'private' stamp: 'DouailleErwan 5/15/2012 15:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSourceCity class methodsFor: 'private' stamp: 'DouailleErwan 5/15/2012 15:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSourceCity class methodsFor: 'metacello tool support' stamp: 'DouailleErwan 5/15/2012 15:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSourceCity class methodsFor: 'loading' stamp: 'DouailleErwan 5/15/2012 15:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSourceCity class methodsFor: 'loading' stamp: 'DouailleErwan 5/15/2012 15:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSourceCity class methodsFor: 'loading' stamp: 'DouailleErwan 5/15/2012 15:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSourceCity class methodsFor: 'accessing' stamp: 'DouailleErwan 5/15/2012 15:40'!
project

	^self new project! !

!ConfigurationOfSourceCity class methodsFor: 'development support' stamp: 'DouailleErwan 5/15/2012 15:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSourceCity methodsFor: 'accessing' stamp: 'blo 7/3/2012 10:03'!
baseline01: spec 
        <version: '0.1-baseline'>
        
        spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/SourceCity'.
		
          	spec package: 'SourceCity-Core' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-Importer' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-OpenGL' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-Tools' with: [ spec requires: 'NBOpenGL' ].	
            spec project: 'NBOpenGL' with: [
			spec
				className: 'ConfigurationOfNBOpenGL';
				loads: #('default');
				file: 'ConfigurationOfNBOpenGL';
				repository: 'http://www.squeaksource.com/NBOpenGL' 
			].
	].

! !

!ConfigurationOfSourceCity methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 11:28'!
baseline02: spec 
        <version: '0.2-baseline'>
        
        spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/SourceCity'.
		
          	spec package: 'SourceCity-Core' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-Importer' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-OpenGL' with: [ spec requires: 'NBOpenGL' ].
		spec package: 'SourceCity-Tools' with: [ spec requires: 'NBOpenGL' ].	
            spec project: 'NBOpenGL' with: [
			spec
				className: 'ConfigurationOfNBOpenGL';
				loads: #('default');
				file: 'ConfigurationOfNBOpenGL';
				repository: 'http://www.squeaksource.com/NBOpenGL' 
			].
	].

! !

!ConfigurationOfSourceCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/15/2012 15:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSourceCity methodsFor: 'accessing' stamp: 'blo 7/3/2012 10:05'!
version01: spec
        <version: '0.1' imports: #('0.1-baseline')>

        spec for: #common do: [
			spec package: 'SourceCity-Core' with: 'SourceCity-Core-DouailleErwan.5'.
			spec package: 'SourceCity-Importer' with: 'SourceCity-Importer-DouailleErwan.5'.
			spec package: 'SourceCity-OpenGL' with: 'SourceCity-OpenGL-DouailleErwan.8'.
			spec package: 'SourceCity-Tools' with: 'SourceCity-Tools-DouailleErwan.7'.
			spec project: 'NBOpenGL' with: '1.0.2'.
		].! !

!ConfigurationOfSourceCity methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 13:57'!
version02: spec
        <version: '0.2' imports: #('0.2-baseline')>

        spec for: #common do: [
			spec package: 'SourceCity-Core' with: 'SourceCity-Core-DouailleErwan.10'.
			spec package: 'SourceCity-Importer' with: 'SourceCity-Importer-DouailleErwan.9'.
			spec package: 'SourceCity-OpenGL' with: 'SourceCity-OpenGL-DouailleErwan.13'.
			spec package: 'SourceCity-Tools' with: 'SourceCity-Tools-DouailleErwan.11'.
			spec project: 'NBOpenGL' with: '1.0.2'.
		].! !
